org.codehaus.plexus.metadata.merge

## Class MXParser

- java.lang.Object
- - org.codehaus.plexus.metadata.merge.MXParser

All Implemented Interfaces:
  org.codehaus.plexus.util.xml.pull.XmlPullParser

    public class MXParser
    extends java.lang.Object
    implements org.codehaus.plexus.util.xml.pull.XmlPullParser

Absolutely minimal implementation of XMLPULL V1 API. Encoding handling done with XmlReader

Author:
  Aleksander Slominski
See Also:
  `XmlReader`

### Field Summary

Fields
`protected boolean` `allStringsInterned` Implementation notice: the is instance variable that controls if newString() is interning.
`protected int` `attributeCount`
`protected java.lang.String[]` `attributeName`
`protected int[]` `attributeNameHash`
`protected java.lang.String[]` `attributePrefix`
`protected java.lang.String[]` `attributeUri`
`protected java.lang.String[]` `attributeValue`
`protected char[]` `buf`
`protected int` `bufAbsoluteStart`
`protected int` `bufEnd`
`protected int` `bufLoadFactor`
`protected int` `bufSoftLimit`
`protected int` `bufStart`
`protected char[]` `charRefOneCharBuf`
`protected int` `columnNumber`
`protected int` `depth`
`protected java.lang.String[]` `elName`
`protected int[]` `elNamespaceCount`
`protected java.lang.String[]` `elPrefix`
`protected char[][]` `elRawName`
`protected int[]` `elRawNameEnd`
`protected int[]` `elRawNameLine`
`protected java.lang.String[]` `elUri`
`protected boolean` `emptyElementTag`
`protected int` `entityEnd`
`protected java.lang.String[]` `entityName`
`protected char[][]` `entityNameBuf`
`protected int[]` `entityNameHash`
`protected java.lang.String` `entityRefName`
`protected java.lang.String[]` `entityReplacement`
`protected char[][]` `entityReplacementBuf`
`protected int` `eventType`
`protected static java.lang.String` `FEATURE_NAMES_INTERNED`
`protected static java.lang.String` `FEATURE_XML_ROUNDTRIP`
`protected java.lang.String` `inputEncoding`
`protected int` `lineNumber`
`protected java.lang.String` `location`
`protected static int` `LOOKUP_MAX`
`protected static char` `LOOKUP_MAX_CHAR`
`protected static boolean[]` `lookupNameChar`
`protected static boolean[]` `lookupNameStartChar`
`protected int` `namespaceEnd`
`protected java.lang.String[]` `namespacePrefix`
`protected int[]` `namespacePrefixHash`
`protected java.lang.String[]` `namespaceUri`
`protected static char[]` `NCODING`
`protected static char[]` `NO`
`protected boolean` `pastEndTag`
`protected char[]` `pc`
`protected int` `pcEnd`
`protected int` `pcStart`
`protected int` `pos`
`protected int` `posEnd`
`protected int` `posStart`
`protected boolean` `preventBufferCompaction`
`protected boolean` `processNamespaces`
`protected static java.lang.String` `PROPERTY_LOCATION`
`protected static java.lang.String` `PROPERTY_XMLDECL_CONTENT`
`protected static java.lang.String` `PROPERTY_XMLDECL_STANDALONE`
`protected static java.lang.String` `PROPERTY_XMLDECL_VERSION`
`protected boolean` `reachedEnd`
`protected static int` `READ_CHUNK_SIZE`
`protected java.io.Reader` `reader`
`protected static java.lang.String` `REPORT_NAMESPACE_PREFIXES`
`protected boolean` `roundtripSupported`
`protected boolean` `seenAmpersand`
`protected boolean` `seenDocdecl`
`protected boolean` `seenEndTag`
`protected boolean` `seenMarkup`
`protected boolean` `seenRoot`
`protected boolean` `seenStartTag`
`protected static char[]` `TANDALONE`
`protected java.lang.String` `text`
`protected boolean` `tokenize`
`protected boolean` `usePC`
`protected static char[]` `VERSION`
`protected static java.lang.String` `XML_URI`
`protected java.lang.String` `xmlDeclContent`
`protected java.lang.Boolean` `xmlDeclStandalone`
`protected java.lang.String` `xmlDeclVersion`
`protected static java.lang.String` `XMLNS_URI`
`protected static char[]` `YES`

### Fields inherited from interface org.codehaus.plexus.util.xml.pull.XmlPullParser

`CDSECT, COMMENT, DOCDECL, END_DOCUMENT, END_TAG, ENTITY_REF, FEATURE_PROCESS_DOCDECL, FEATURE_PROCESS_NAMESPACES, FEATURE_REPORT_NAMESPACE_ATTRIBUTES, FEATURE_VALIDATION, IGNORABLE_WHITESPACE, NO_NAMESPACE, PROCESSING_INSTRUCTION, START_DOCUMENT, START_TAG, TEXT, TYPES`

### Constructor Summary

Constructors
Constructor and Description
`MXParser()`

### Method Summary

Methods
`void` `defineEntityReplacementText(java.lang.String entityName, java.lang.String replacementText)`
`protected void` `ensureAttributesCapacity(int size)` Make sure that in attributes temporary array is enough space.
`protected void` `ensureElementsCapacity()` Make sure that we have enough space to keep element stack if passed size.
`protected void` `ensureEntityCapacity()`
`protected void` `ensureNamespacesCapacity(int size)`
`protected void` `ensurePC(int end)`
`protected static int` `fastHash(char[] ch, int off, int len)` simplistic implementation of hash function that has constant time to compute - so it also means diminishing hash quality for long strings but for XML parsing it should be good enough ...
`protected void` `fillBuf()`
`int` `getAttributeCount()`
`java.lang.String` `getAttributeName(int index)`
`java.lang.String` `getAttributeNamespace(int index)`
`java.lang.String` `getAttributePrefix(int index)`
`java.lang.String` `getAttributeType(int index)`
`java.lang.String` `getAttributeValue(int index)`
`java.lang.String` `getAttributeValue(java.lang.String namespace, java.lang.String name)`
`int` `getColumnNumber()`
`int` `getDepth()`
`int` `getEventType()`
`boolean` `getFeature(java.lang.String name)` Unknown properties are <string>always returned as false
`java.lang.String` `getInputEncoding()`
`int` `getLineNumber()`
`java.lang.String` `getName()`
`java.lang.String` `getNamespace()`
`java.lang.String` `getNamespace(java.lang.String prefix)`
`int` `getNamespaceCount(int depth)`
`java.lang.String` `getNamespacePrefix(int pos)`
`java.lang.String` `getNamespaceUri(int pos)`
`java.lang.String` `getPositionDescription()` Return string describing current position of parsers as text 'STATE [seen %s...] @line:column'.
`java.lang.String` `getPrefix()`
`java.lang.Object` `getProperty(java.lang.String name)`
`java.lang.String` `getText()`
`char[]` `getTextCharacters(int[] holderForStartAndLength)`
`boolean` `isAttributeDefault(int index)`
`boolean` `isEmptyElementTag()`
`protected boolean` `isNameChar(char ch)`
`protected boolean` `isNameStartChar(char ch)`
`protected boolean` `isS(char ch)`
`boolean` `isWhitespace()`
`protected void` `joinPC()`
`protected char[]` `lookuEntityReplacement(int entitNameLen)`
`protected char` `more()`
`protected java.lang.String` `newString(char[] cbuf, int off, int len)`
`protected java.lang.String` `newStringIntern(char[] cbuf, int off, int len)`
`int` `next()`
`protected int` `nextImpl()`
`int` `nextTag()`
`java.lang.String` `nextText()`
`int` `nextToken()`
`protected char` `parseAttribute()`
`protected void` `parseCDSect(boolean hadCharData)`
`protected void` `parseComment()`
`protected void` `parseDocdecl()`
`int` `parseEndTag()`
`protected char[]` `parseEntityRef()`
`protected int` `parseEpilog()`
`protected boolean` `parsePI()`
`protected int` `parseProlog()`
`int` `parseStartTag()`
`protected void` `parseXmlDecl(char ch)`
`protected void` `parseXmlDeclWithVersion(int versionStart, int versionEnd)`
`protected java.lang.String` `printable(char ch)`
`protected java.lang.String` `printable(java.lang.String s)`
`void` `require(int type, java.lang.String namespace, java.lang.String name)`
`protected char` `requireInput(char ch, char[] input)`
`protected char` `requireNextS()`
`protected void` `reset()`
`protected void` `resetStringCache()`
`void` `setFeature(java.lang.String name, boolean state)` Method setFeature
`void` `setInput(java.io.InputStream inputStream, java.lang.String inputEncoding)`
`void` `setInput(java.io.Reader in)`
`void` `setProperty(java.lang.String name, java.lang.Object value)`
`protected char` `skipS(char ch)`
`void` `skipSubTree()` Skip sub tree that is currently porser positioned on.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### XML_URI

    protected static final java.lang.String XML_URI

See Also:
  Constant Field Values

#### XMLNS_URI

    protected static final java.lang.String XMLNS_URI

See Also:
  Constant Field Values

#### FEATURE_XML_ROUNDTRIP

    protected static final java.lang.String FEATURE_XML_ROUNDTRIP

See Also:
  Constant Field Values

#### FEATURE_NAMES_INTERNED

    protected static final java.lang.String FEATURE_NAMES_INTERNED

See Also:
  Constant Field Values

#### PROPERTY_XMLDECL_VERSION

    protected static final java.lang.String PROPERTY_XMLDECL_VERSION

See Also:
  Constant Field Values

#### PROPERTY_XMLDECL_STANDALONE

    protected static final java.lang.String PROPERTY_XMLDECL_STANDALONE

See Also:
  Constant Field Values

#### PROPERTY_XMLDECL_CONTENT

    protected static final java.lang.String PROPERTY_XMLDECL_CONTENT

See Also:
  Constant Field Values

#### PROPERTY_LOCATION

    protected static final java.lang.String PROPERTY_LOCATION

See Also:
  Constant Field Values

#### REPORT_NAMESPACE_PREFIXES

    protected static final java.lang.String REPORT_NAMESPACE_PREFIXES

See Also:
  Constant Field Values

#### allStringsInterned

    protected boolean allStringsInterned

Implementation notice: the is instance variable that controls if newString() is interning.

NOTE: newStringIntern always returns interned strings and newString MAY return interned String depending on this variable.

NOTE: by default in this minimal implementation it is false!

#### usePC

    protected boolean usePC

#### seenStartTag

    protected boolean seenStartTag

#### seenEndTag

    protected boolean seenEndTag

#### pastEndTag

    protected boolean pastEndTag

#### seenAmpersand

    protected boolean seenAmpersand

#### seenMarkup

    protected boolean seenMarkup

#### seenDocdecl

    protected boolean seenDocdecl

#### tokenize

    protected boolean tokenize

#### text

    protected java.lang.String text

#### entityRefName

    protected java.lang.String entityRefName

#### xmlDeclVersion

    protected java.lang.String xmlDeclVersion

#### xmlDeclStandalone

    protected java.lang.Boolean xmlDeclStandalone

#### xmlDeclContent

    protected java.lang.String xmlDeclContent

#### processNamespaces

    protected boolean processNamespaces

#### roundtripSupported

    protected boolean roundtripSupported

#### location

    protected java.lang.String location

#### lineNumber

    protected int lineNumber

#### columnNumber

    protected int columnNumber

#### seenRoot

    protected boolean seenRoot

#### reachedEnd

    protected boolean reachedEnd

#### eventType

    protected int eventType

#### emptyElementTag

    protected boolean emptyElementTag

#### depth

    protected int depth

#### elRawName

    protected char[][] elRawName

#### elRawNameEnd

    protected int[] elRawNameEnd

#### elRawNameLine

    protected int[] elRawNameLine

#### elName

    protected java.lang.String[] elName

#### elPrefix

    protected java.lang.String[] elPrefix

#### elUri

    protected java.lang.String[] elUri

#### elNamespaceCount

    protected int[] elNamespaceCount

#### READ_CHUNK_SIZE

    protected static final int READ_CHUNK_SIZE

See Also:
  Constant Field Values

#### reader

    protected java.io.Reader reader

#### inputEncoding

    protected java.lang.String inputEncoding

#### bufLoadFactor

    protected int bufLoadFactor

#### buf

    protected char[] buf

#### bufSoftLimit

    protected int bufSoftLimit

#### preventBufferCompaction

    protected boolean preventBufferCompaction

#### bufAbsoluteStart

    protected int bufAbsoluteStart

#### bufStart

    protected int bufStart

#### bufEnd

    protected int bufEnd

#### pos

    protected int pos

#### posStart

    protected int posStart

#### posEnd

    protected int posEnd

#### pc

    protected char[] pc

#### pcStart

    protected int pcStart

#### pcEnd

    protected int pcEnd

#### attributeCount

    protected int attributeCount

#### attributeName

    protected java.lang.String[] attributeName

#### attributeNameHash

    protected int[] attributeNameHash

#### attributePrefix

    protected java.lang.String[] attributePrefix

#### attributeUri

    protected java.lang.String[] attributeUri

#### attributeValue

    protected java.lang.String[] attributeValue

#### namespaceEnd

    protected int namespaceEnd

#### namespacePrefix

    protected java.lang.String[] namespacePrefix

#### namespacePrefixHash

    protected int[] namespacePrefixHash

#### namespaceUri

    protected java.lang.String[] namespaceUri

#### entityEnd

    protected int entityEnd

#### entityName

    protected java.lang.String[] entityName

#### entityNameBuf

    protected char[][] entityNameBuf

#### entityReplacement

    protected java.lang.String[] entityReplacement

#### entityReplacementBuf

    protected char[][] entityReplacementBuf

#### entityNameHash

    protected int[] entityNameHash

#### charRefOneCharBuf

    protected char[] charRefOneCharBuf

#### VERSION

    protected static final char[] VERSION

#### NCODING

    protected static final char[] NCODING

#### TANDALONE

    protected static final char[] TANDALONE

#### YES

    protected static final char[] YES

#### NO

    protected static final char[] NO

#### LOOKUP_MAX

    protected static final int LOOKUP_MAX

See Also:
  Constant Field Values

#### LOOKUP_MAX_CHAR

    protected static final char LOOKUP_MAX_CHAR

See Also:
  Constant Field Values

#### lookupNameStartChar

    protected static boolean[] lookupNameStartChar

#### lookupNameChar

    protected static boolean[] lookupNameChar

### Constructor Detail

#### MXParser

    public MXParser()

### Method Detail

#### resetStringCache

    protected void resetStringCache()

#### newString

    protected java.lang.String newString(char[] cbuf,
                             int off,
                             int len)

#### newStringIntern

    protected java.lang.String newStringIntern(char[] cbuf,
                                   int off,
                                   int len)

#### ensureElementsCapacity

    protected void ensureElementsCapacity()

Make sure that we have enough space to keep element stack if passed size. It will always create one additional slot then current depth

#### ensureAttributesCapacity

    protected void ensureAttributesCapacity(int size)

Make sure that in attributes temporary array is enough space.

#### ensureNamespacesCapacity

    protected void ensureNamespacesCapacity(int size)

#### fastHash

    protected static final int fastHash(char[] ch,
               int off,
               int len)

simplistic implementation of hash function that has constant time to compute - so it also means diminishing hash quality for long strings but for XML parsing it should be good enough ...

#### ensureEntityCapacity

    protected void ensureEntityCapacity()

#### reset

    protected void reset()

#### setFeature

    public void setFeature(java.lang.String name,
                  boolean state)
                    throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Method setFeature

Specified by:
  `setFeature` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Parameters:
  `name` - a String
  `state` - a boolean
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getFeature

    public boolean getFeature(java.lang.String name)

Unknown properties are <string>always returned as false

Specified by:
  `getFeature` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### setProperty

    public void setProperty(java.lang.String name,
                   java.lang.Object value)
                     throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `setProperty` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getProperty

    public java.lang.Object getProperty(java.lang.String name)

Specified by:
  `getProperty` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### setInput

    public void setInput(java.io.Reader in)
                  throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `setInput` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### setInput

    public void setInput(java.io.InputStream inputStream,
                java.lang.String inputEncoding)
                  throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `setInput` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getInputEncoding

    public java.lang.String getInputEncoding()

Specified by:
  `getInputEncoding` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### defineEntityReplacementText

    public void defineEntityReplacementText(java.lang.String entityName,
                                   java.lang.String replacementText)
                                     throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `defineEntityReplacementText` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getNamespaceCount

    public int getNamespaceCount(int depth)
                          throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `getNamespaceCount` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getNamespacePrefix

    public java.lang.String getNamespacePrefix(int pos)
                                        throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `getNamespacePrefix` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getNamespaceUri

    public java.lang.String getNamespaceUri(int pos)
                                     throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `getNamespaceUri` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getNamespace

    public java.lang.String getNamespace(java.lang.String prefix)

Specified by:
  `getNamespace` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getDepth

    public int getDepth()

Specified by:
  `getDepth` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getPositionDescription

    public java.lang.String getPositionDescription()

Return string describing current position of parsers as text 'STATE [seen %s...] @line:column'.

Specified by:
  `getPositionDescription` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getLineNumber

    public int getLineNumber()

Specified by:
  `getLineNumber` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getColumnNumber

    public int getColumnNumber()

Specified by:
  `getColumnNumber` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### isWhitespace

    public boolean isWhitespace()
                         throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `isWhitespace` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getText

    public java.lang.String getText()

Specified by:
  `getText` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getTextCharacters

    public char[] getTextCharacters(int[] holderForStartAndLength)

Specified by:
  `getTextCharacters` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getNamespace

    public java.lang.String getNamespace()

Specified by:
  `getNamespace` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getName

    public java.lang.String getName()

Specified by:
  `getName` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getPrefix

    public java.lang.String getPrefix()

Specified by:
  `getPrefix` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### isEmptyElementTag

    public boolean isEmptyElementTag()
                              throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `isEmptyElementTag` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### getAttributeCount

    public int getAttributeCount()

Specified by:
  `getAttributeCount` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getAttributeNamespace

    public java.lang.String getAttributeNamespace(int index)

Specified by:
  `getAttributeNamespace` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getAttributeName

    public java.lang.String getAttributeName(int index)

Specified by:
  `getAttributeName` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getAttributePrefix

    public java.lang.String getAttributePrefix(int index)

Specified by:
  `getAttributePrefix` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getAttributeType

    public java.lang.String getAttributeType(int index)

Specified by:
  `getAttributeType` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### isAttributeDefault

    public boolean isAttributeDefault(int index)

Specified by:
  `isAttributeDefault` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getAttributeValue

    public java.lang.String getAttributeValue(int index)

Specified by:
  `getAttributeValue` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getAttributeValue

    public java.lang.String getAttributeValue(java.lang.String namespace,
                                     java.lang.String name)

Specified by:
  `getAttributeValue` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`

#### getEventType

    public int getEventType()
                     throws org.codehaus.plexus.util.xml.pull.XmlPullParserException

Specified by:
  `getEventType` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### require

    public void require(int type,
               java.lang.String namespace,
               java.lang.String name)
                 throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                        java.io.IOException

Specified by:
  `require` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### skipSubTree

    public void skipSubTree()
                     throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                            java.io.IOException

Skip sub tree that is currently porser positioned on.
NOTE: parser must be on START_TAG and when funtion returns parser will be positioned on corresponding END_TAG

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### nextText

    public java.lang.String nextText()
                              throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                     java.io.IOException

Specified by:
  `nextText` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### nextTag

    public int nextTag()
                throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                       java.io.IOException

Specified by:
  `nextTag` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### next

    public int next()
             throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                    java.io.IOException

Specified by:
  `next` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### nextToken

    public int nextToken()
                  throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                         java.io.IOException

Specified by:
  `nextToken` in interface `org.codehaus.plexus.util.xml.pull.XmlPullParser`
Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### nextImpl

    protected int nextImpl()
                    throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                           java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseProlog

    protected int parseProlog()
                       throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                              java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseEpilog

    protected int parseEpilog()
                       throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                              java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseEndTag

    public int parseEndTag()
                    throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                           java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseStartTag

    public int parseStartTag()
                      throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                             java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseAttribute

    protected char parseAttribute()
                           throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                  java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseEntityRef

    protected char[] parseEntityRef()
                             throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                    java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### lookuEntityReplacement

    protected char[] lookuEntityReplacement(int entitNameLen)
                                     throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                            java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseComment

    protected void parseComment()
                         throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parsePI

    protected boolean parsePI()
                       throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                              java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseXmlDecl

    protected void parseXmlDecl(char ch)
                         throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseXmlDeclWithVersion

    protected void parseXmlDeclWithVersion(int versionStart,
                               int versionEnd)
                                    throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                           java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseDocdecl

    protected void parseDocdecl()
                         throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### parseCDSect

    protected void parseCDSect(boolean hadCharData)
                        throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                               java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### fillBuf

    protected void fillBuf()
                    throws java.io.IOException,
                           org.codehaus.plexus.util.xml.pull.XmlPullParserException

Throws:
  `java.io.IOException`
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### more

    protected char more()
                 throws java.io.IOException,
                        org.codehaus.plexus.util.xml.pull.XmlPullParserException

Throws:
  `java.io.IOException`
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`

#### ensurePC

    protected void ensurePC(int end)

#### joinPC

    protected void joinPC()

#### requireInput

    protected char requireInput(char ch,
                    char[] input)
                         throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### requireNextS

    protected char requireNextS()
                         throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                                java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### skipS

    protected char skipS(char ch)
                  throws org.codehaus.plexus.util.xml.pull.XmlPullParserException,
                         java.io.IOException

Throws:
  `org.codehaus.plexus.util.xml.pull.XmlPullParserException`
  `java.io.IOException`

#### isNameStartChar

    protected boolean isNameStartChar(char ch)

#### isNameChar

    protected boolean isNameChar(char ch)

#### isS

    protected boolean isS(char ch)

#### printable

    protected java.lang.String printable(char ch)

#### printable

    protected java.lang.String printable(java.lang.String s)